//
// Programmer:    Craig Stuart Sapp
// Creation Date: Sat Feb 14 02:50:18 GMT-0800 1998
// Last Modified: Sat Feb 14 02:50:24 GMT-0800 1998
// Filename:      ...sig/code/control/PadPage/PadPage.h
// Syntax:        C++ 
// $Smake:        cc -Wall -g -c %b.cc -I../../../include && rm -f %b.o
//
// Description:   useful for parameter organization.
//

#ifndef _PADPAGE_H_INCLUDED
#define _PADPAGE_H_INCLUDED


template<class type>
class PadPage {
   public:
               PadPage             (int size = 1024);
              ~PadPage             (void);

      int      aquire              (void);        
      void     empty               (void);       
      void     free                (int index);
      void     initialize          (type& aThing);
      int      insert              (type& aThing);
      int      getNumFreeSpaces    (void) const;
      int      getNumUsedSpaces    (void) const;
      int      getSize             (void) const;
      int      getStatus           (int index); 
      type&    operator[]          (int index);
      void     setSize             (int aSize);


   protected:
      int      arraySize;     // maximum number of items in list
      type*    array;         // storage space for items
      char*    cellUsage;     // 1=used, 0=free
      int*     cellFree;      // storage space for free cell location numbers
      int      listTopFree;   // pointer to next free cell location in cellsFree

};



#endif  // _PADPAGE_H_INCLUDED



